#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TurretPosCFG.h"
std::auto_ptr<Fish_TurretPosCFG> Fish_TurretPosCFG::msSingleton(nullptr);

int Fish_TurretPosCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TurretPosCFGData* Fish_TurretPosCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TurretPosCFGData>& Fish_TurretPosCFG::GetMapData()
{
	return mMapData;
}

void Fish_TurretPosCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TurretPosCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TurretPosCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mX = element->IntAttribute("X");
		data.mY = element->IntAttribute("Y");
		data.mIsFlippedY = element->BoolAttribute("IsFlippedY");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TurretPosCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TurretPosCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TurretPosCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TurretPosCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TurretPosCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "X", data.mX);
		LuaCfgHelper::readInt(L, "Y", data.mY);
		LuaCfgHelper::readBool(L, "IsFlippedY", data.mIsFlippedY);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TurretPosCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TurretPosCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TurretPosCFG* Fish_TurretPosCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TurretPosCFG());
	}
	return msSingleton.get();
}

void Fish_TurretPosCFG::Release()
{
	msSingleton.reset(nullptr);
}
